/*
 * Created on 23.09.2008
 *
 */
package com.eaio.twitterbackup.entities;


/**
 * Encapsulates a single status update aka "Tweet."
 * 
 * @author <a href="mailto:jb&#64;eaio.com">Johann Burkard</a>
 * @version $Id: Status.java 7347 2015-06-01 10:07:07Z johann $
 */
public class Status implements Comparable<Status> {
    
    String contributors;

    String coordinates;
    
    String created_at;
    
    StatusEntities entities;
    
    String favorite_count;

    boolean favorited;
    
    String geo;
    
    long id;
    
    String id_str;
    
    String in_reply_to_screen_name;

    String in_reply_to_status_id;
    
    String in_reply_to_status_id_str;
    
    String in_reply_to_user_id;
    
    String in_reply_to_user_id_str;

    String lang;
    
    String place;
    
    boolean possibly_sensitive;

    String retweet_count;
    
    boolean retweeted;
    
    Status retweeted_status;
    
    String source;
    
    String text;

    boolean truncated;

    User user;
    
    ExtendedEntities extended_entities;
    
    boolean is_quote_status;
    
    long quoted_status_id;
    
    String quoted_status_id_str;
    
    String quoted_status;
    
    /**
     * @see java.lang.Object#equals(java.lang.Object)
     */
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (!(obj instanceof Status)) {
            return false;
        }
        return id == ((Status) obj).id;
    }

    /**
     * @see java.lang.Object#hashCode()
     */
    public int hashCode() {
        return (int) (id ^ (id >> 32));
    }

    /**
     * @see java.lang.Comparable#compareTo(java.lang.Object)
     */
    public int compareTo(Status o) {
        return id > o.id ? -1 : (id == o.id ? 0 : 1);
    }

}
